<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="dispatches"
    :page="page+1"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
    @click:row="goToDetails"
  >
    <template #top>
      <v-row no-gutters justify="end">
        <v-col cols="3">
          <v-select
            v-model="stateSelected"
            :items="DispatchStatus"
            class="mx-2"
          />
        </v-col>
      </v-row>
    </template>
    <template #item.id="{ item }">
      {{ hashId(item) }}
    </template>
    <template #item.departureTime="{ item }">
      {{ toLocalDate(item.departureTime) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { errorOptions } from '~/helpers/toast';
import { hashId } from '~/helpers/format/ids';
import { toLocalDate } from '~/helpers/format/time';
import DispatchStatus, { PENDING } from '~/services/programming/dispatch-status';

export default {
  name: 'DispatchsTable',
  data: () => ({
    DispatchStatus,
    stateSelected: PENDING,
    loading: false,
    search: '',
    headers: [
      { text: 'Nª', align: 'start', sortable: false, value: 'id' },
      { text: 'Hora de salida', sortable: false, value: 'departureTime' },
      { text: 'Pedidos programados', sortable: false, value: 'cantProgrammedOrders' },
      { text: 'Estado', sortable: false, value: 'state' },
    ],
  }),
  computed: {
    ...mapState({
      dispatches: state => state.programming.dispatches.dispatches,
      page: state => state.programming.dispatches.pageInfo.page,
      pageSize: state => state.programming.dispatches.pageInfo.pageSize,
      total: state => state.programming.dispatches.pageInfo.total,
    }),
  },
  watch: {
    stateSelected() {
      this.getDispatchesData();
    },
  },
  async mounted() {
    await this.getDispatchesData();
  },
  methods: {
    ...mapActions({
      getDispatches: 'programming/dispatches/getDispatches',
    }),
    hashId,
    toLocalDate,
    async getDispatchesData() {
      this.loading = true;
      try {
        await this.getDispatches({ state: this.stateSelected });
      } catch (e) {
        this.$toast.error('No se pudo obtener los despachos programados', errorOptions);
      }
      this.loading = false;
    },
    async goToDetails({ id }) {
      await this.$router.push(`/programacion/despachos/${id}`);
    },
  },
};
</script>
